// Copyright 2021 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

package v1beta1

import (
	corev1 "k8s.io/api/core/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	clusterv1 "sigs.k8s.io/cluster-api/api/v1beta1"
)

const (
	// HostCleanupAnnotation annotation used to mark a host for cleanup
	HostCleanupAnnotation = "byoh.infrastructure.cluster.x-k8s.io/unregistering"
	// EndPointIPAnnotation annotation used to store the IP address of the endpoint
	EndPointIPAnnotation = "byoh.infrastructure.cluster.x-k8s.io/endpointip"
	// K8sVersionAnnotation annotation used to store the k8s version
	K8sVersionAnnotation = "byoh.infrastructure.cluster.x-k8s.io/k8sversion"
	// AttachedByoMachineLabel label used to mark a node name attached to a byo host
	AttachedByoMachineLabel = "byoh.infrastructure.cluster.x-k8s.io/byomachine-name"
	// BundleLookupBaseRegistryAnnotation annotation used to store the base registry for the bundle lookup
	BundleLookupBaseRegistryAnnotation = "byoh.infrastructure.cluster.x-k8s.io/bundle-registry"
	// MachineFinalizer allows ReconcileByoMachine to clean up Byo
	// resources associated with ByoMachine before removing it from the
	// API Server.
	MachineFinalizer = "byomachine.infrastructure.cluster.x-k8s.io"

	// BYOHostReady documents the k8s node is ready and can take on workloads
	BYOHostReady clusterv1.ConditionType = "BYOHostReady"

	// DefaultClusterName is the cluster name used in the generated bootstrap-kubeconfig
	DefaultClusterName = "default-cluster"

	// DefaultContext is the context name used in the generated bootstrap-kubeconfig
	DefaultContext = "default-context"

	// DefaultNamespace is the namespace used in the generated bootstrap-kubeconfig
	DefaultNamespace = "default"

	// DefaultAuth is the auth in the generated bootstrap-kubeconfig
	DefaultAuth = "default-auth"

	// BootstrapTokenDescription is the bootstrap token description for the secret that is generated
	BootstrapTokenDescription = "Token generated by cluster-api-provider-bringyourownhost"

	// BootstrapTokenExtraGroups is the byoh group that has access to create CertificateSigningRequest
	BootstrapTokenExtraGroups = "system:bootstrappers:byoh"
)

// ByoMachineSpec defines the desired state of ByoMachine
// +kubebuilder:object:generate=true
type ByoMachineSpec struct {
	// Label Selector to choose the byohost
	Selector *metav1.LabelSelector `json:"selector,omitempty"`

	ProviderID string `json:"providerID,omitempty"`

	// InstallerRef is an optional reference to a installer-specific resource that holds
	// the details of InstallationSecret to be used to install BYOH Bundle.
	// +optional
	InstallerRef *corev1.ObjectReference `json:"installerRef,omitempty"`
}

// ByoMachineStatus defines the observed state of ByoMachine
// +kubebuilder:object:generate=true
type ByoMachineStatus struct {
	// INSERT ADDITIONAL STATUS FIELD - define observed state of cluster
	// Important: Run "make" to regenerate code after modifying this file

	// HostInfo has the attached host platform details.
	// +optional
	HostInfo HostInfo `json:"hostinfo,omitempty"`

	// +optional
	Ready bool `json:"ready"`

	// Conditions defines current service state of the BYOMachine.
	// +optional
	Conditions clusterv1.Conditions `json:"conditions,omitempty"`
}

//+kubebuilder:object:root=true
//+kubebuilder:resource:path=byomachines,scope=Namespaced,shortName=byom
//+kubebuilder:subresource:status

// ByoMachine is the Schema for the byomachines API
type ByoMachine struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   ByoMachineSpec   `json:"spec,omitempty"`
	Status ByoMachineStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// ByoMachineList contains a list of ByoMachine
type ByoMachineList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []ByoMachine `json:"items"`
}

// ByoHostSpec defines the desired state of ByoHost
// +kubebuilder:object:generate=true
type ByoHostSpec struct {
	// BootstrapSecret is an optional reference to a Cluster API Secret
	// for bootstrap purpose
	// +optional
	BootstrapSecret *corev1.ObjectReference `json:"bootstrapSecret,omitempty"`

	// InstallationSecret is an optional reference to InstallationSecret
	// generated by InstallerController for K8s installation
	// +optional
	InstallationSecret *corev1.ObjectReference `json:"installationSecret,omitempty"`

	// UninstallationScript is an optional field to store uninstall script
	// generated by InstallerController
	// +optional
	UninstallationScript *string `json:"uninstallationScript,omitempty"`
}

// HostInfo is a set of details about the host platform.
type HostInfo struct {
	// The Operating System reported by the host.
	OSName string `json:"osname,omitempty"`

	// OS Image reported by the host.
	OSImage string `json:"osimage,omitempty"`

	// The Architecture reported by the host.
	Architecture string `json:"architecture,omitempty"`
}

// ByoHostStatus defines the observed state of ByoHost
// +kubebuilder:object:generate=true
type ByoHostStatus struct {
	// MachineRef is an optional reference to a Cluster API Machine
	// using this host.
	// +optional
	MachineRef *corev1.ObjectReference `json:"machineRef,omitempty"`

	// Conditions defines current service state of the BYOMachine.
	// +optional
	Conditions clusterv1.Conditions `json:"conditions,omitempty"`

	// HostDetails returns the platform details of the host.
	// +optional
	HostDetails HostInfo `json:"hostinfo,omitempty"`

	// Network returns the network status for each of the host's configured
	// network interfaces.
	// +optional
	Network []NetworkStatus `json:"network,omitempty"`
}

// NetworkStatus provides information about one of a VM's networks.
// +kubebuilder:object:generate=true
type NetworkStatus struct {
	// Connected is a flag that indicates whether this network is currently
	// connected to the VM.
	Connected bool `json:"connected,omitempty"`

	// IPAddrs is one or more IP addresses reported by vm-tools.
	// +optional
	IPAddrs []string `json:"ipAddrs,omitempty"`

	// MACAddr is the MAC address of the network device.
	MACAddr string `json:"macAddr"`

	// NetworkInterfaceName is the name of the network interface.
	// +optional
	NetworkInterfaceName string `json:"networkInterfaceName,omitempty"`

	// IsDefault is a flag that indicates whether this interface name is where
	// the default gateway sit on.
	IsDefault bool `json:"isDefault,omitempty"`
}

//+kubebuilder:object:root=true
//+kubebuilder:resource:path=byohosts,scope=Namespaced,shortName=byoh
//+kubebuilder:subresource:status
//+kubebuilder:printcolumn:name="OSName",type="string",JSONPath=`.status.hostinfo.osname`
//+kubebuilder:printcolumn:name="OSImage",type="string",JSONPath=`.status.hostinfo.osimage`
//+kubebuilder:printcolumn:name="Arch",type="string",JSONPath=`.status.hostinfo.architecture`

// ByoHost is the Schema for the byohosts API
type ByoHost struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   ByoHostSpec   `json:"spec,omitempty"`
	Status ByoHostStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// ByoHostList contains a list of ByoHost
type ByoHostList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []ByoHost `json:"items"`
}

// BootstrapKubeconfigSpec defines the desired state of BootstrapKubeconfig
type BootstrapKubeconfigSpec struct {
	// APIServer is the address of the kubernetes cluster (https://hostname:port).
	APIServer string `json:"apiserver"`

	// InsecureSkipTLSVerify skips the validity check for the server's certificate. This will make your HTTPS connections insecure.
	InsecureSkipTLSVerify bool `json:"insecure-skip-tls-verify,omitempty"`

	// CertificateAuthorityData contains PEM-encoded certificate authority certificates.
	CertificateAuthorityData string `json:"certificate-authority-data"`
}

// BootstrapKubeconfigStatus defines the observed state of BootstrapKubeconfig
// +kubebuilder:object:generate=true

type BootstrapKubeconfigStatus struct {
	// BootstrapKubeconfigData is an optional reference to a bootstrap kubeconfig info
	// for starting the host registration process
	BootstrapKubeconfigData *string `json:"bootstrapKubeconfigData,omitempty"`
}

//+kubebuilder:object:root=true

// BootstrapKubeconfig is the Schema for the bootstrapkubeconfigs API
type BootstrapKubeconfig struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   BootstrapKubeconfigSpec   `json:"spec,omitempty"`
	Status BootstrapKubeconfigStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// BootstrapKubeconfigList contains a list of BootstrapKubeconfig
type BootstrapKubeconfigList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []BootstrapKubeconfig `json:"items"`
}

func init() {
	SchemeBuilder.Register(&ByoHost{}, &ByoHostList{})
	SchemeBuilder.Register(&ByoMachine{}, &ByoMachineList{})
	SchemeBuilder.Register(&BootstrapKubeconfig{}, &BootstrapKubeconfigList{})

}

// GetConditions returns the conditions of ByoMachine status
func (byoMachine *ByoMachine) GetConditions() clusterv1.Conditions {
	return byoMachine.Status.Conditions
}

// SetConditions sets the conditions of ByoMachine status
func (byoMachine *ByoMachine) SetConditions(conditions clusterv1.Conditions) {
	byoMachine.Status.Conditions = conditions
}

// GetConditions gets the ByoHost status conditions
func (byoHost *ByoHost) GetConditions() clusterv1.Conditions {
	return byoHost.Status.Conditions
}

// SetConditions sets the ByoHost status conditions
func (byoHost *ByoHost) SetConditions(conditions clusterv1.Conditions) {
	byoHost.Status.Conditions = conditions
}
